float scale = 1;

SamplerState linearSampler : IMMUTABLE
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Clamp;
    AddressV = Clamp;
};
 

cbuffer cbPerDraw : register( b0 )
{
	float4x4 tVP : LAYERVIEWPROJECTION;	
};

cbuffer cbPerObj : register( b1 )
{
	float4x4 tW : WORLD;
};


float3 geo_Quad[4] : IMMUTABLE =
{
	float3( -0.5,0.5,0.0),	
	float3(0.5,0.5,0.0),
	float3( -0.5,-0.5,0.0),
	float3(  0.5,-0.5,0.0),
};


int geo_QuadIndexBuffer[4] : IMMUTABLE =
{
	0,2,1,3
};


struct vsIn
{
	float4 Pos : POSITION;
};

struct gsIn
{	
    float4 Pos : POSITION;
};

struct psIn
{
    float4 Pos: SV_Position;
};

gsIn VS(vsIn input)
{
    return input;
}


[maxvertexcount(4)]
void GS(point gsIn input[1], inout TriangleStream<psIn> OutputStream )
{
    psIn output;
	
	for(int i=0; i<4; i++)
	    {
	        output.Pos = float4(geo_Quad[geo_QuadIndexBuffer[i]] * scale + input[0].Pos.xyz, 1);	
	    	OutputStream .Append(output);
	    }	
}


float4 PS( psIn In): SV_Target
{
    return float4(1,0,0,1);
}





technique10 Constant
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS() ) );
		SetGeometryShader( CompileShader( gs_4_0, GS() ) );
		SetPixelShader( CompileShader( ps_4_0, PS() ) );
	}
}




